library VirtualLCD;

uses
  SysUtils,
  Classes,
  Windows,
  StrUtils,
  Messages;

{$R *.res}

var mut : THandle;

type TCharArray = array[0..7] of char;


procedure SendMessage(p:pchar);
var
  Bytes: DWord;
  slot : THandle;
begin
  slot := CreateFile('\\.\mailslot\LCDMail', GENERIC_WRITE, FILE_SHARE_READ, nil, OPEN_EXISTING {CREATE_ALWAYS}, FILE_ATTRIBUTE_NORMAL, 0);
  try
    if slot = INVALID_HANDLE_VALUE then
      Exit
    else
     WriteFile(slot, p^, Length(p), Bytes, nil);
  finally
    CloseHandle(slot);
  end;
end;

procedure DISPLAYDLL_Init(const x_size : byte; const y_size : byte; const startparam :pchar; ok : pbool); stdcall;
begin

  ok^ := true;
  Mut := CreateMutex(nil, false, 'VIRTUAL_LCD');
  if not ((Mut = 0) or (GetLastError = ERROR_ALREADY_EXISTS)) then
  begin
    MessageBox(0,'Start VirtualLCD.exe before using this DLL!','Error',mb_iconstop);
  end;
  if mut <> 0 then
    CloseHandle(mut);

   SendMessage(pchar('INIT'#13#10+inttostr(x_size)+#13#10+inttostr(y_size)));
end;


function  DISPLAYDLL_DriverName():pchar;stdcall;
begin
 result := 'ART VirtualLCD DLL v1.0';
end;

function  DISPLAYDLL_Usage():pchar;stdcall;
begin
  result := 'Start VirtualLCD.exe';
end;

function  DISPLAYDLL_DefaultParameters():pchar;stdcall;
begin
  result := #0;
end;

Function DISPLAYDLL_CustomCharIndex(Index : byte):byte;stdcall;
begin
  result := Index;
end;



procedure DISPLAYDLL_Done() ; stdcall;
begin
 PostMessage(FindWindow(Nil, 'VirtualLCD'), WM_QUIT, 0, 0);
end;

procedure DISPLAYDLL_SetContrast(const val:byte); stdcall;
begin
  SendMessage(pchar('CONTRAST'#13#10+inttostr(val)));
end;

procedure DISPLAYDLL_SetBrightness(const val:byte); stdcall;
begin
  SendMessage(pchar('BRIGHTNESS'#13#10+inttostr(val)));
end;

procedure DISPLAYDLL_Write(const str : pchar); stdcall;
begin
  SendMessage(pchar('WRITE'#13#10+str));
end;

procedure DISPLAYDLL_SetPosition(const x:byte; const y:byte); stdcall;
begin
  SendMessage(pchar('SETPOS'#13#10+inttostr(x-1)+#13#10+inttostr(y-1)));
end;


procedure DISPLAYDLL_CustomChar(const ascii:byte; bitmap : TCharArray); stdcall;
var s:string;
    i:integer;
begin
  s := '';
  for I := 0 to 7 do
  begin
   s := s+#13#10+inttostr(byte(bitmap[i]));
  end;
  SendMessage(pchar('CHAR'#13#10+inttostr(ascii)+s));
end;

procedure DISPLAYDLL_SetBacklight(LightOn : boolean); stdcall;
begin
  SendMessage(pchar('BACKLIGHT'#13#10+ifthen(LightOn,'1','0')));
end;

exports
DISPLAYDLL_Init,
DISPLAYDLL_DriverName,
DISPLAYDLL_Usage,
DISPLAYDLL_DefaultParameters,
DISPLAYDLL_Done,
DISPLAYDLL_SetContrast,
DISPLAYDLL_SetBrightness,
DISPLAYDLL_Write,
DISPLAYDLL_SetPosition,
DISPLAYDLL_CustomChar,
DISPLAYDLL_SetBackLight,
DISPLAYDLL_CustomCharIndex;

begin
end.
