unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Buttons, artlcd;

type
  TMainForm = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    dll: TComboBox;
    lDName: TLabel;
    lUsage: TLabel;
    lDefParam: TLabel;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    eSizex: TEdit;
    esizey: TEdit;
    Label4: TLabel;
    eparams: TEdit;
    Button1: TButton;
    GroupBox3: TGroupBox;
    Label5: TLabel;
    tbBright: TTrackBar;
    Label6: TLabel;
    tbContrast: TTrackBar;
    cbLight: TCheckBox;
    GroupBox4: TGroupBox;
    Label7: TLabel;
    Txt: TMemo;
    Button2: TButton;
    GroupBox5: TGroupBox;
    sb04: TSpeedButton;
    sb14: TSpeedButton;
    sb24: TSpeedButton;
    sb34: TSpeedButton;
    sb44: TSpeedButton;
    sb54: TSpeedButton;
    sb64: TSpeedButton;
    sb74: TSpeedButton;
    sb03: TSpeedButton;
    sb13: TSpeedButton;
    sb23: TSpeedButton;
    sb33: TSpeedButton;
    sb43: TSpeedButton;
    sb53: TSpeedButton;
    sb63: TSpeedButton;
    sb73: TSpeedButton;
    sb02: TSpeedButton;
    sb01: TSpeedButton;
    sb12: TSpeedButton;
    sb11: TSpeedButton;
    sb22: TSpeedButton;
    sb21: TSpeedButton;
    sb32: TSpeedButton;
    sb31: TSpeedButton;
    sb42: TSpeedButton;
    sb41: TSpeedButton;
    sb52: TSpeedButton;
    sb51: TSpeedButton;
    sb62: TSpeedButton;
    sb61: TSpeedButton;
    sb72: TSpeedButton;
    sb71: TSpeedButton;
    sb00: TSpeedButton;
    sb10: TSpeedButton;
    sb20: TSpeedButton;
    sb30: TSpeedButton;
    sb40: TSpeedButton;
    sb50: TSpeedButton;
    sb60: TSpeedButton;
    sb70: TSpeedButton;
    Button3: TButton;
    Button4: TButton;
    Lcd: TArtLCD;
    procedure FormShow(Sender: TObject);
    procedure dllChange(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure cbLightClick(Sender: TObject);
    procedure tbBrightChange(Sender: TObject);
    procedure tbContrastChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    path:string;
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.Button1Click(Sender: TObject);
begin
 lcd.SizeX := strtointdef(eSizex.Text,16);
 lcd.SizeY := strtointdef(eSizey.Text,2);
 lcd.StartParam := eparams.Text;
 if not lcd.init then
 begin
  Application.MessageBox('Error while initialization!','Error',MB_ICONSTOP);
  exit;
 end;
 tbBright.Position := lcd.Brightness;
 tbContrast.Position := lcd.Contrast;
 cbLight.Checked := lcd.BackLight;
end;

procedure TMainForm.Button2Click(Sender: TObject);
var s:string;
    i : integer;
begin
   lcd.PosX := 0;
   for I:= 0 to txt.Lines.Count-1 do
   begin
     s := txt.Lines[i];
     if length(s)<lcd.SizeX then
       s := s + StringOfChar(' ',lcd.SizeX-length(s))
     else if length(s)>lcd.SizeX then
       s := copy(s,1,lcd.SizeX);

     lcd.PosY := i;
     lcd.Write(s);
   end;
end;

procedure TMainForm.Button3Click(Sender: TObject);
var ch : TCharBitmap;
    i,j : integer;
    x : byte;
begin
  for i:= 0 to 7 do
  begin
    x := 0;
    for j := 0 to 4 do
      if TSpeedButton(self.FindComponent('sb'+inttostr(i)+inttostr(j))).Down then
       x := x + 1 shl j;
    ch[i] := chr(x);
  end;
  lcd.SetCustomChar(0,ch);
  for i := 0 to lcd.SizeY-1 do
   lcd.WriteXY(0,i,stringofchar(lcd.customchar[0],lcd.sizex));

end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
 lcd.Done;
 close;
end;

procedure TMainForm.cbLightClick(Sender: TObject);
begin
  lcd.BackLight := cbLight.Checked;
end;

procedure TMainForm.dllChange(Sender: TObject);
begin
 lcd.DLLName := path + dll.Text;
 lDName.Caption := lcd.DriverName;
 lUsage.Caption := lcd.Usage;
 lDefParam.Caption := lcd.DefaultParameters;
 eparams.Text := lcd.DefaultParameters;
end;

procedure TMainForm.FormShow(Sender: TObject);
var fs : TSearchRec;
begin
 path := ExtractFilePath(Application.ExeName);
 if FindFirst(pchar(path+'*.dll'),0,fs)=0 then
 begin
   dll.Items.Add(fs.Name);
   while FindNext(fs)=0 do
    dll.Items.Add(fs.Name);
 end;
 FindClose(fs);
end;

procedure TMainForm.tbBrightChange(Sender: TObject);
begin
 lcd.Brightness := tbBright.Position;
end;

procedure TMainForm.tbContrastChange(Sender: TObject);
begin
 lcd.Contrast := tbContrast.Position;
end;

end.
