unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, strutils;

{.$DEFINE DEBUG}

type
  TCharArray = array[0..7] of char;
  TMainForm = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    slot : THandle;
    MSize, MCount: DWord;
    Msg: TStringList;
  public
   w,h,posx,posy:integer;
   bmp : TBitmap;
   brightness, contrast, backlight : byte;
   buffer : array of array of char;
   bg, fg : TColor;
{$IFDEF DEBUG}
   tf : TextFile;
{$ENDIF}
   procedure Init(ww,hh:integer);
   procedure SetBrightness(b:byte);
   procedure SetBackLight(b:boolean);
   procedure SetContrast(b:byte);
   procedure Putc(c:char;x,y:integer);
   procedure Setxy(x,y:integer);
   procedure Write(s:pchar);
   procedure CustomChar(c:byte;data : TCharArray);
   procedure DoPaint;
  end;

var
  MainForm: TMainForm;

implementation

const ps = 4;

l1 = '   Virtual LCD  ';
l2 = '(c) ArtSoft 2010';

CTable : array[0..255] of array [0..7] of char =
(
(#0, #0, #0, #0, #0, #0, #0,  #0),
(#14, #17, #27, #17, #31, #17, #14,  #0),
(#14, #31, #21, #31, #17, #31, #14,  #0),
(#0, #10, #31, #31, #31, #14, #4,  #0),
(#0, #4, #14, #31, #14, #4, #0,  #0),
(#4, #14, #14, #27, #14, #4, #14,  #0),
(#4, #14, #31, #31, #14, #4, #14,  #0),
(#0, #0, #0, #0, #0, #0, #0,  #0),
(#0, #0, #0, #0, #0, #0, #0,  #0),
(#0, #0, #0, #0, #0, #0, #0,  #0),
(#0, #0, #0, #0, #0, #0, #0,  #0),
(#7, #3, #5, #12, #18, #18, #12,  #0),
(#14, #17, #17, #14, #4, #31, #4,  #0),
(#15, #9, #15, #8, #8, #24, #24,  #0),
(#15, #9, #15, #9, #9, #27, #27,  #0),
(#4, #21, #14, #27, #14, #21, #4,  #0),
(#16, #24, #28, #30, #28, #24, #16,  #0),
(#2, #6, #14, #30, #14, #6, #2,  #0),
(#4, #14, #31, #4, #31, #14, #4,  #0),
(#10, #10, #10, #10, #10, #0, #10,  #0),
(#15, #21, #21, #21, #13, #5, #5,  #0),
(#6, #9, #4, #10, #4, #18, #12,  #0),
(#0, #0, #0, #0, #30, #30, #0,  #0),
(#4, #14, #31, #4, #31, #14, #31,  #0),
(#4, #14, #31, #4, #4, #4, #4,  #0),
(#4, #4, #4, #4, #31, #14, #4,  #0),
(#0, #4, #6, #31, #6, #4, #0,  #0),
(#0, #4, #12, #31, #12, #4, #0,  #0),
(#0, #0, #12, #12, #15, #0, #0,  #0),
(#0, #0, #10, #31, #10, #0, #0,  #0),
(#0, #0, #4, #14, #31, #0, #0,  #0),
(#0, #0, #31, #14, #4, #0, #0,  #0),
(#0, #0, #0, #0, #0, #0, #0,  #0),
(#8, #8, #8, #8, #8, #0, #8,  #0),
(#10, #10, #0, #0, #0, #0, #0,  #0),
(#0, #10, #31, #10, #31, #10, #0,  #0),
(#4, #15, #20, #14, #5, #30, #4,  #0),
(#24, #25, #2, #4, #8, #19, #3,  #0),
(#8, #20, #20, #8, #21, #18, #13,  #0),
(#4, #8, #0, #0, #0, #0, #0,  #0),
(#2, #4, #8, #8, #8, #4, #2,  #0),
(#8, #4, #2, #2, #2, #4, #8,  #0),
(#4, #21, #14, #31, #14, #21, #4,  #0),
(#0, #4, #4, #31, #4, #4, #0,  #0),
(#0, #0, #0, #0, #0, #12, #24,  #0),
(#0, #0, #0, #30, #0, #0, #0,  #0),
(#0, #0, #0, #0, #0, #12, #12,  #0),
(#1, #2, #2, #4, #8, #8, #16,  #0),
(#14, #17, #19, #21, #25, #17, #14,  #0),
(#4, #12, #4, #4, #4, #4, #14,  #0),
(#14, #17, #1, #2, #4, #8, #31,  #0),
(#14, #17, #1, #6, #1, #17, #14,  #0),
(#2, #6, #10, #18, #31, #2, #2,  #0),
(#31, #16, #30, #1, #1, #17, #14,  #0),
(#6, #8, #16, #30, #17, #17, #14,  #0),
(#31, #1, #2, #4, #8, #8, #8,  #0),
(#14, #17, #17, #14, #17, #17, #14,  #0),
(#14, #17, #17, #15, #1, #1, #14,  #0),
(#0, #12, #12, #0, #12, #12, #0,  #0),
(#0, #6, #6, #0, #6, #6, #12,  #0),
(#2, #4, #8, #16, #8, #4, #2,  #0),
(#0, #0, #30, #0, #30, #0, #0,  #0),
(#16, #8, #4, #2, #4, #8, #16,  #0),
(#14, #17, #1, #2, #4, #0, #4,  #0),
(#14, #17, #23, #21, #23, #16, #15,  #0),
(#4, #10, #17, #17, #31, #17, #17,  #0),
(#30, #17, #17, #30, #17, #17, #30,  #0),
(#14, #17, #16, #16, #16, #17, #14,  #0),
(#30, #17, #17, #17, #17, #17, #30,  #0),
(#31, #16, #16, #30, #16, #16, #31,  #0),
(#31, #16, #16, #30, #16, #16, #16,  #0),
(#14, #17, #16, #23, #17, #17, #14,  #0),
(#17, #17, #17, #31, #17, #17, #17,  #0),
(#14, #4, #4, #4, #4, #4, #14,  #0),
(#2, #2, #2, #2, #2, #18, #12,  #0),
(#17, #18, #20, #24, #20, #18, #17,  #0),
(#16, #16, #16, #16, #16, #16, #31,  #0),
(#17, #27, #21, #21, #17, #17, #17,  #0),
(#17, #25, #21, #19, #17, #17, #17,  #0),
(#14, #17, #17, #17, #17, #17, #14,  #0),
(#30, #17, #17, #30, #16, #16, #16,  #0),
(#14, #17, #17, #17, #21, #18, #13,  #0),
(#30, #17, #17, #30, #20, #18, #17,  #0),
(#14, #17, #16, #14, #1, #17, #14,  #0),
(#31, #4, #4, #4, #4, #4, #4,  #0),
(#17, #17, #17, #17, #17, #17, #14,  #0),
(#17, #17, #17, #17, #17, #10, #4,  #0),
(#17, #17, #17, #21, #21, #21, #10,  #0),
(#17, #17, #10, #4, #10, #17, #17,  #0),
(#17, #17, #17, #10, #4, #4, #4,  #0),
(#31, #1, #2, #4, #8, #16, #31,  #0),
(#12, #8, #8, #8, #8, #8, #12,  #0),
(#16, #8, #8, #4, #2, #2, #1,  #0),
(#12, #4, #4, #4, #4, #4, #12,  #0),
(#4, #10, #0, #0, #0, #0, #0,  #0),
(#0, #0, #0, #0, #0, #0, #31,  #0),
(#8, #4, #0, #0, #0, #0, #0,  #0),
(#0, #0, #14, #1, #15, #17, #15,  #0),
(#16, #16, #30, #17, #17, #17, #30,  #0),
(#0, #0, #15, #16, #16, #16, #15,  #0),
(#1, #1, #15, #17, #17, #17, #15,  #0),
(#0, #0, #14, #17, #31, #16, #15,  #0),
(#6, #8, #28, #8, #8, #8, #8,  #0),
(#0, #0, #15, #17, #15, #1, #30,  #0),
(#16, #16, #22, #25, #17, #17, #17,  #0),
(#4, #0, #4, #4, #4, #4, #4,  #0),
(#4, #0, #4, #4, #4, #20, #8,  #0),
(#16, #16, #18, #20, #24, #20, #18,  #0),
(#4, #4, #4, #4, #4, #4, #4,  #0),
(#0, #0, #10, #21, #21, #17, #17,  #0),
(#0, #0, #22, #25, #17, #17, #17,  #0),
(#0, #0, #14, #17, #17, #17, #14,  #0),
(#0, #0, #28, #18, #28, #16, #16,  #0),
(#0, #0, #14, #18, #14, #2, #2,  #0),
(#0, #0, #22, #24, #16, #16, #16,  #0),
(#0, #0, #15, #16, #14, #1, #30,  #0),
(#4, #4, #14, #4, #4, #4, #6,  #0),
(#0, #0, #18, #18, #18, #18, #12,  #0),
(#0, #0, #17, #17, #10, #10, #4,  #0),
(#0, #0, #17, #17, #21, #21, #10,  #0),
(#0, #0, #17, #10, #4, #10, #17,  #0),
(#0, #0, #18, #18, #14, #2, #28,  #0),
(#0, #0, #31, #2, #4, #8, #31,  #0),
(#2, #4, #4, #8, #4, #4, #2,  #0),
(#4, #4, #4, #0, #4, #4, #4,  #0),
(#8, #4, #4, #2, #4, #4, #8,  #0),
(#8, #21, #2, #0, #0, #0, #0,  #0),
(#0, #14, #10, #10, #10, #14, #0,  #0),
(#6, #9, #28, #8, #28, #9, #6,  #0),
(#0, #14, #10, #10, #10, #14, #0,  #0),
(#0, #0, #0, #12, #12, #4, #8,  #0),
(#6, #9, #8, #30, #8, #8, #16,  #0),
(#0, #0, #0, #27, #27, #9, #18,  #0),
(#0, #0, #0, #0, #21, #0, #0,  #0),
(#4, #4, #31, #4, #4, #4, #4,  #0),
(#4, #4, #31, #4, #31, #4, #4,  #0),
(#4, #10, #0, #0, #0, #0, #0,  #0),
(#25, #26, #4, #11, #19, #12, #12,  #0),
(#10, #4, #15, #16, #14, #1, #30,  #0),
(#0, #2, #4, #8, #4, #2, #0,  #0),
(#15, #20, #20, #23, #20, #20, #15,  #0),
(#0, #14, #10, #10, #10, #14, #0,  #0),
(#10, #4, #31, #2, #4, #8, #31,  #0),
(#0, #14, #10, #10, #10, #14, #0,  #0),
(#0, #14, #10, #10, #10, #14, #0,  #0),
(#2, #4, #6, #6, #0, #0, #0,  #0),
(#12, #12, #4, #8, #0, #0, #0,  #0),
(#9, #18, #27, #27, #0, #0, #0,  #0),
(#27, #27, #9, #18, #0, #0, #0,  #0),
(#0, #14, #31, #31, #31, #14, #0,  #0),
(#0, #0, #0, #14, #0, #0, #0,  #0),
(#0, #0, #0, #31, #0, #0, #0,  #0),
(#10, #20, #0, #0, #0, #0, #0,  #0),
(#31, #11, #11, #0, #0, #0, #0,  #0),
(#10, #4, #15, #16, #14, #1, #30,  #0),
(#0, #8, #4, #2, #4, #8, #0,  #0),
(#0, #0, #14, #21, #23, #20, #15,  #0),
(#0, #14, #10, #10, #10, #14, #0,  #0),
(#10, #4, #31, #2, #4, #8, #31,  #0),
(#10, #0, #17, #17, #14, #4, #4,  #0),
(#0, #0, #0, #0, #0, #0, #0,  #0),
(#12, #0, #12, #12, #12, #12, #12,  #0),
(#4, #14, #21, #20, #21, #14, #4,  #0),
(#14, #17, #8, #30, #4, #9, #30,  #0),
(#0, #17, #14, #10, #14, #17, #0,  #0),
(#17, #17, #14, #31, #4, #31, #4,  #0),
(#12, #12, #12, #0, #12, #12, #12,  #0),
(#6, #9, #4, #10, #4, #18, #12,  #0),
(#27, #27, #0, #0, #0, #0, #0,  #0),
(#14, #21, #27, #25, #27, #21, #14,  #0),
(#12, #2, #14, #18, #14, #0, #0,  #0),
(#0, #5, #10, #20, #10, #5, #0,  #0),
(#0, #0, #0, #30, #2, #0, #0,  #0),
(#0, #0, #0, #14, #0, #0, #0,  #0),
(#14, #29, #27, #27, #29, #27, #14,  #0),
(#0, #31, #0, #0, #0, #0, #0,  #0),
(#4, #10, #4, #0, #0, #0, #0,  #0),
(#0, #4, #14, #4, #0, #14, #0,  #0),
(#12, #18, #4, #8, #30, #0, #0,  #0),
(#12, #18, #4, #18, #12, #0, #0,  #0),
(#2, #4, #8, #0, #0, #0, #0,  #0),
(#0, #17, #17, #27, #21, #16, #16,  #0),
(#15, #21, #21, #21, #13, #5, #5,  #0),
(#0, #0, #0, #12, #12, #0, #0,  #0),
(#0, #0, #0, #0, #4, #2, #12,  #0),
(#4, #12, #4, #4, #14, #0, #0,  #0),
(#12, #18, #18, #18, #12, #0, #0,  #0),
(#0, #20, #10, #5, #10, #20, #0,  #0),
(#17, #18, #20, #9, #21, #7, #1,  #0),
(#17, #18, #20, #14, #17, #2, #7,  #0),
(#24, #5, #10, #5, #29, #23, #1,  #0),
(#4, #0, #4, #12, #17, #17, #14,  #0),
(#8, #4, #4, #10, #17, #31, #17,  #0),
(#2, #4, #4, #10, #17, #31, #17,  #0),
(#4, #10, #4, #10, #17, #31, #17,  #0),
(#10, #20, #4, #10, #17, #31, #17,  #0),
(#10, #0, #4, #10, #17, #31, #17,  #0),
(#4, #0, #4, #10, #17, #31, #17,  #0),
(#15, #20, #20, #31, #20, #20, #23,  #0),
(#14, #17, #16, #17, #14, #2, #12,  #0),
(#8, #4, #31, #16, #28, #16, #31,  #0),
(#4, #8, #31, #16, #28, #16, #31,  #0),
(#4, #10, #30, #16, #28, #16, #30,  #0),
(#20, #0, #30, #16, #28, #16, #30,  #0),
(#8, #4, #14, #4, #4, #4, #14,  #0),
(#2, #4, #14, #4, #4, #4, #14,  #0),
(#4, #10, #14, #4, #4, #4, #14,  #0),
(#10, #0, #14, #4, #4, #4, #14,  #0),
(#30, #9, #9, #29, #9, #9, #30,  #0),
(#5, #10, #17, #25, #21, #19, #17,  #0),
(#8, #4, #14, #17, #17, #17, #14,  #0),
(#2, #4, #14, #17, #17, #17, #14,  #0),
(#4, #10, #14, #17, #17, #17, #14,  #0),
(#10, #20, #14, #17, #17, #17, #14,  #0),
(#10, #0, #14, #17, #17, #17, #14,  #0),
(#0, #0, #17, #10, #4, #10, #17,  #0),
(#14, #17, #19, #21, #25, #17, #14,  #0),
(#8, #4, #17, #17, #17, #17, #14,  #0),
(#2, #4, #17, #17, #17, #17, #14,  #0),
(#4, #10, #17, #17, #17, #17, #14,  #0),
(#10, #0, #17, #17, #17, #17, #14,  #0),
(#2, #4, #17, #17, #14, #4, #4,  #0),
(#16, #16, #28, #18, #28, #16, #16,  #0),
(#12, #18, #18, #30, #17, #25, #22,  #0),
(#8, #4, #14, #1, #15, #17, #15,  #0),
(#2, #4, #14, #1, #15, #17, #15,  #0),
(#4, #10, #14, #1, #15, #17, #15,  #0),
(#10, #20, #14, #1, #15, #17, #15,  #0),
(#10, #0, #14, #1, #15, #17, #15,  #0),
(#4, #0, #14, #1, #15, #17, #15,  #0),
(#0, #0, #31, #5, #31, #20, #31,  #0),
(#0, #6, #9, #8, #9, #6, #12,  #0),
(#8, #4, #14, #17, #30, #16, #15,  #0),
(#2, #4, #14, #17, #30, #16, #15,  #0),
(#4, #10, #14, #17, #30, #16, #15,  #0),
(#10, #0, #14, #17, #30, #16, #15,  #0),
(#8, #4, #0, #4, #4, #4, #4,  #0),
(#2, #4, #0, #4, #4, #4, #4,  #0),
(#4, #10, #0, #4, #4, #4, #4,  #0),
(#0, #10, #0, #4, #4, #4, #4,  #0),
(#20, #8, #20, #6, #9, #9, #6,  #0),
(#10, #20, #0, #22, #25, #17, #17,  #0),
(#8, #4, #0, #14, #17, #17, #14,  #0),
(#2, #4, #0, #14, #17, #17, #14,  #0),
(#4, #10, #0, #14, #17, #17, #14,  #0),
(#10, #20, #0, #14, #17, #17, #14,  #0),
(#0, #10, #0, #14, #17, #17, #14,  #0),
(#0, #4, #0, #14, #0, #4, #0,  #0),
(#0, #0, #14, #19, #21, #25, #14,  #0),
(#8, #4, #0, #17, #17, #19, #13,  #0),
(#2, #4, #0, #17, #17, #19, #13,  #0),
(#4, #10, #0, #17, #17, #19, #13,  #0),
(#0, #10, #0, #17, #17, #19, #13,  #0),
(#2, #4, #17, #17, #14, #4, #4,  #0),
(#16, #30, #17, #17, #30, #16, #16,  #0),
(#10, #0, #17, #17, #14, #4, #4,  #0));


procedure TMainform.SetBrightness(b:byte);
var x:byte;
begin
 brightness := b;
 x := (brightness div 2 + 128) div backlight;
 fg := rgb(x,x,x);
 Dopaint;
end;

procedure TMainform.SetContrast(b:byte);
begin
 contrast := b;
 bg := RGB(0,0,contrast*192 div 256 div backlight);
 Dopaint;
end;

procedure TMainform.SetBackLight(b:boolean);
var x:byte;
begin
  if b then backlight := 1 else backlight := 2;
  x := (brightness div 2 + 128) div backlight;
  fg := rgb(x,x,x);
  bg := RGB(0,0,contrast*192 div 256 div backlight);
  DoPaint;
end;

procedure Tmainform.CustomChar(c:byte;data :TCharArray);
var i : integer;
begin
 for i := 0 to 7 do
  CTable[c,i] := data[i];
end;


procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 FreeAndNil(Msg);
 CloseHandle(slot);
{$IFDEF DEBUF}
 closefile(tf);
{$ENDIF}
end;

procedure TMainForm.FormCreate(Sender: TObject);
var i:integer;
begin
{$IFDEF DEBUG}
 AssignFile(tf,'VirtualLCD.log');
 rewrite(tf);
{$ENDIF}
 bmp := TBitmap.Create;
 w := 16;
 h := 2;
 posx := 0;
 posy := 0;
 ClientWidth := w*ps*6+6;
 ClientHeight := h*ps*9+6;
 bmp.Width := ClientWidth;
 bmp.Height := ClientHeight;
 contrast := 128;
 brightness := 128;
 backlight := 1;
 bg := RGB(0,0,contrast*192 div 256);
 fg := rgb(brightness div 2 + 128,brightness div 2 + 128,brightness div 2 + 128,);
 SetLength(buffer,16,2);
 for i:= 0 to 15 do
 begin
   buffer[i][0] := l1[i+1];
   buffer[i][1] := l2[i+1];
 end;
 Msg := TStringList.Create;
 slot := CreateMailSlot('\\.\mailslot\LCDMail', 0, 100, nil);
 if slot = INVALID_HANDLE_VALUE then
 begin
   Raise Exception.Create('Cant create mailslot!');
   close;
 end;
end;

procedure TMainForm.putc(c:char;x,y:integer);
var i,j,k,l:integer;
begin
  for i := 0 to 7 do
   for j := 0 to 4 do
    if ((byte(CTable[byte(c)][i]) shr j) and 1) = 1 then
       for k := 0 to ps-1 do
         for l := 0 to ps - 1 do
           bmp.Canvas.Pixels[ps*2-1+x*6*ps+k+ps*(4-j), ps*2-1+y*ps*9+i*ps+l] := fg;
end;


procedure TMainForm.write(s:pchar);
var i:integer;
begin
  if posy>=h then exit;
  for i := posx to w-posx-1 do
   if s[i-posx]=#0 then break
   else buffer[i,posy] := s[i-posx];
  Dopaint;
end;

procedure TMainForm.setxy(x,y:integer);
begin
  posx := x;
  posy := y;
end;


procedure TMainForm.Timer1Timer(Sender: TObject);
var
  NewMessage:String;
  Bytes: DWord;
  i : integer;
  ch : TCharArray;
begin
  GetMailSlotInfo(slot, nil, MSize, @MCount, nil);
        while MCount > 0 do
        begin
          if (MSize <> MAILSLOT_NO_MESSAGE) then
          begin
            SetLength(NewMessage, MSize);
            if ReadFile(slot, PChar(NewMessage)^, MSize, Bytes, nil) then
            begin
              Msg.Clear;
              Msg.Text := NewMessage;
{$IFDEF DEBUG}
              WriteLn(tf,'----  '+formatdatetime('dd.mm.yyy hh:nn:ss',now));
              Writeln(tf, NewMessage); 
{$ENDIF}
            try
              if Msg[0] = 'INIT' then
              begin
                Init(strtointdef(Msg[1],16),strtointdef(Msg[2],2));
              end
              else
              if Msg[0] = 'SETPOS' then
              begin
                setxy(strtointdef(Msg[1],0),strtointdef(Msg[2],0));
              end
              else
              if Msg[0] = 'WRITE' then
              begin
                Write(pchar(Msg[1]));
              end
              else
              if Msg[0] = 'BRIGHTNESS' then
              begin
                SetBrightness(strtointdef(Msg[1],128));
              end
              else
              if Msg[0] = 'CONTRAST' then
              begin
                SetContrast(strtointdef(Msg[1],128));
              end
              else
              if Msg[0] = 'BACKLIGHT' then
              begin
                SetBackLight(strtointdef(Msg[1],0)=1);
              end
              else
              if Msg[0] = 'CHAR' then
              begin
               for I := 0 to 7 do
                ch[i] := chr(strtointdef(Msg[i+2],0));
               CustomChar(strtointdef(Msg[1],0), ch);
              end
            except

            end;
            end;
          end;
          GetMailSlotInfo(slot, nil, MSize, @MCount, nil);
        end;
end;

procedure TMainForm.FormPaint(Sender: TObject);
begin
 DoPaint;
end;


procedure TMainForm.DoPaint;
var i,j:integer;
begin
 bmp.Canvas.Brush.Color := RGB(0,0,255 div backlight);
 bmp.Canvas.FillRect(bmp.Canvas.ClipRect);
 bmp.Canvas.Brush.Color := bg;

 for i := 0 to h - 1 do
  for J := 0 to w - 1 do
  begin
   bmp.Canvas.FillRect(Rect(ps*2-1+j*ps*6,ps*2-1+i*ps*9,ps*2-1+j*ps*6+ps*5,ps*2-1+i*ps*9+ps*8));
   putc(buffer[j,i],j,i);
  end;

 Canvas.Draw(0,0,bmp);
end;

procedure TMainForm.Init(ww,hh:integer);
var i,j:integer;
begin
 w := ww;
 h := hh;
 posx := 0;
 posy := 0;
 ClientWidth := w*ps*6+ps*3;
 ClientHeight := h*ps*9+ps*3;
 bmp.Width := ClientWidth;
 bmp.Height := ClientHeight;
 SetLength(buffer,w,h);
 for I := 0 to w-1 do
  for j := 0 to h - 1 do
   buffer[i,j] := ' ';

   
 Dopaint;
end;

{$R *.dfm}

end.
